//+------------------------------------------------------------------+
//|                                                      lyliaEA.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

extern string SetOrders         = "==== Set Orders ====";
extern bool   UseTakeProfit     = true;     // Use take profit
extern double TakeProfit        = 25;       // Profit for all orders
extern bool   UseStopLoss       = true;     // Use stop loss
extern double StopLoss          = 25;       // Loss for all orders
extern bool   UseTrailingStop   = false;    // Use trailing stop loss
extern double TrailingStop      = 20;       // Pips for trailing stop
extern string LotSize           = "==== Set Lot ====";
extern double lots              = 0.1;
extern string MagicNumber       = "==== Set Magic ====";
extern int    mn                = 7777;
//------------------------------------
int slip=3;
string ExpertName;
int MultiplierPoint;
double DigitPoint;
double StopLevel;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
ExpertName=WindowExpertName();   
//------------------------------------------------------
//Broker 4 or 5 digits
DigitPoint=MarketInfo(Symbol(),MODE_POINT);
MultiplierPoint=1;
if(MarketInfo(Symbol(),MODE_DIGITS)==3||MarketInfo(Symbol(),MODE_DIGITS)==5)
{
MultiplierPoint=10;
DigitPoint*=MultiplierPoint;
}
//---
slip*=MultiplierPoint;
//------------------------------------------------------
//Minimum trailing, take profit and stop loss
StopLevel=MathMax(MarketInfo(Symbol(),MODE_FREEZELEVEL)/MultiplierPoint,MarketInfo(Symbol(),MODE_STOPLEVEL)/MultiplierPoint);
if((TakeProfit>0)&&(TakeProfit<StopLevel)) TakeProfit=StopLevel;
if((StopLoss>0)&&(StopLoss<StopLevel)) StopLoss=StopLevel;
if((TrailingStop>0)&&(TrailingStop<StopLevel)) TrailingStop=StopLevel;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
datetime data;
int start()
  {
    int i,nt;
    string sym=Symbol();
    double signalup=iCustom(Symbol(),0,"IINWMARROWS",0,1);
    double signaldown=iCustom(Symbol(),0,"IINWMARROWS",1,1);
    if(data!=iTime(Symbol(),0,0))
    {
      if(signalup!=EMPTY_VALUE&&signalup!=0)
      {
        if(openpos()>0)
        {
          for(i=0;i<OrdersTotal();i++)
          if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
          {
            if(OrderType()==OP_SELL&&OrderSymbol()==Symbol()&&OrderMagicNumber()==mn)
            {
             if(OrderClose(OrderTicket(),lots,Ask,slip))
              Print("short was closed");
            }
          }
        }
        Print("try open long");
        Print(Symbol());
        nt=OrderSend(Symbol(),OP_BUY,lots,Ask,slip,0,0,"lyliaEA",mn,0,Green);
        if(nt>0)
         Print("long order was opened");
         ModifyOrders();
      }
      
      if(signaldown!=EMPTY_VALUE&&signaldown!=0)
      {
        if(openpos()>0)
        {
          for(i=0;i<OrdersTotal();i++)
          if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
          {
            if(OrderType()==OP_BUY&&OrderSymbol()==Symbol()&&OrderMagicNumber()==mn)
            {
              if(OrderClose(OrderTicket(),lots,Bid,slip))
               Print("long was closed");
            }
          }
        }
        Print("try open short");
        Print(Symbol());
        nt=OrderSend(Symbol(),OP_SELL,lots,Bid,slip,0,0,"lyliaEA",mn,0,Red);
        if(nt>0)
         Print("short was opened");
         ModifyOrders();
      }
      data=iTime(Symbol(),0,0);
      
    }
//----
     if(UseTrailingStop==true)  ModifyOrders();
//----
   return(0);
  }
//+------------------------------------------------------------------+

 int openpos()
  {
   int j=0;
   int i,n;
   n=OrdersTotal();
   for(i=0;i<n;i++)
   {
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
     if(OrderSymbol()==Symbol()&&OrderMagicNumber()==mn&&(OrderType()==OP_SELL||OrderType()==OP_BUY))
     j++;
   }
   return(j);
 } 
 //===================================================================================================================//
//modify orders function
void ModifyOrders()
{
double LocalTakeProfit=0;
double LocalStopLoss=0;
bool WasOrderModified;
string CommentModify;
int TryCnt=0;
//------------------------------------------------------
//Select order
for(int i=0; i<OrdersTotal(); i++)
{
if(OrderSelect(i,SELECT_BY_POS))
{
if((OrderMagicNumber()==mn)&&(OrderSymbol()==Symbol()))
{
//------------------------------------------------------
//ok orders
if((((UseTakeProfit==true)&&(OrderTakeProfit()!=0))||((UseTakeProfit==false)&&(OrderTakeProfit()==0)))&&(((UseStopLoss==true)&&(OrderStopLoss()!=0))||((UseStopLoss==false)&&(OrderStopLoss()!=0)))) continue;
//------------------------------------------------------
//Modify buy
if(OrderType()==OP_BUY)
{
TryCnt=0;
LocalStopLoss=0.0;
LocalTakeProfit=0.0;
//------------------------------------------------------
//missing stoploss and/or take profit
if((UseStopLoss==true)&&(OrderStopLoss()==0)) LocalStopLoss=NormalizeDouble(Bid-StopLoss*DigitPoint,Digits);
if((UseTakeProfit==true)&&(OrderTakeProfit()==0)) LocalTakeProfit=NormalizeDouble(Ask+TakeProfit*DigitPoint,Digits);
//------------------------------------------------------
while(true)
{
//-----------------------
//Trailing stop
if((LocalStopLoss==0)&&(TrailingStop>0)&&(NormalizeDouble(Bid-TrailingStop*DigitPoint,Digits)>OrderStopLoss()))
{
LocalStopLoss=NormalizeDouble(Bid-TrailingStop*DigitPoint,Digits);
CommentModify="trailing stop";
}
//-----------------------
//Modify
if(((LocalStopLoss>0)&&(LocalStopLoss!=NormalizeDouble(OrderStopLoss(),Digits))&&(OrderStopLoss()!=0))||(((LocalStopLoss>0)&&(OrderStopLoss()==0))||((LocalTakeProfit>0)&&(OrderTakeProfit()==0))))
{
WasOrderModified=OrderModify(OrderTicket(),0,LocalStopLoss,LocalTakeProfit,0,Blue);
TryCnt++;
}
else break;
//---
if(WasOrderModified>0)
{
Print(ExpertName+": Modify buy by "+CommentModify+", ticket "+OrderTicket());
break;
}
//---Close market
if(GetLastError()==132)
{
Print(ExpertName+": Could not modify, ticket: "+OrderTicket()+", market is closed");
break;
}
//---try 3 times to modify
if(TryCnt==3)
{
Print(ExpertName+": Could not modify ticket "+OrderTicket());
break;
}
//---
else
{
Print("Error: ",GetLastError()+" || "+ExpertName+": Receives new data and try again modify order");
RefreshRates();
}
//---
}//End while(true)
}//End if(OrderType()
//------------------------------------------------------
//Modify sell
if(OrderType()==OP_SELL)
{
TryCnt=0;
LocalStopLoss=0.0;
LocalTakeProfit=0.0;
//------------------------------------------------------
//missing stoploss and/or take profit
if((UseStopLoss==true)&&(OrderStopLoss()==0)) LocalStopLoss=NormalizeDouble(Ask+StopLoss*DigitPoint,Digits);
if((UseTakeProfit==true)&&(OrderTakeProfit()==0)) LocalTakeProfit=NormalizeDouble(Bid-TakeProfit*DigitPoint,Digits);
//------------------------------------------------------
while(true)
{
//-----------------------
//Trailing stop
if((LocalStopLoss==0)&&(TrailingStop>0)&&(NormalizeDouble(Ask+TrailingStop*DigitPoint,Digits)<OrderStopLoss()))
{
LocalStopLoss=NormalizeDouble(Ask+TrailingStop*DigitPoint,Digits);
CommentModify="trailing stop";
}
//-----------------------
//Modify
if(((LocalStopLoss>0)&&(LocalStopLoss!=NormalizeDouble(OrderStopLoss(),Digits))&&(OrderStopLoss()!=0))||(((LocalStopLoss>0)&&(OrderStopLoss()==0))||((LocalTakeProfit>0)&&(OrderTakeProfit()==0))))
{
WasOrderModified=OrderModify(OrderTicket(),0,LocalStopLoss,LocalTakeProfit,0,Red);
TryCnt++;
}
else break;
//---
if(WasOrderModified>0)
{
Print(ExpertName+": Modify sell by "+CommentModify+", ticket "+OrderTicket());
break;
}
//---Close market
if(GetLastError()==132)
{
Print(ExpertName+": Could not modify, ticket: "+OrderTicket()+", market is closed");
break;
}
//---try 3 times to modify
if(TryCnt==3)
{
Print(ExpertName+": Could not modify ticket "+OrderTicket());
break;
}
//---
else
{
Print("Error: ",GetLastError()+" || "+ExpertName+": Receives new data and try again modify order");
RefreshRates();
}
//---
}//End while(true)
}//End if(OrderType()
//------------------------------------------------------
}//End if((OrderSymbol()...
}//End OrderSelect(...
}//End for(...
return(0);
}
//===================================================================================================================//

